__rcs_id__ = """$Id: uData.py 308554 2007-11-26 06:09:46Z cs $"""
import uSysDB
import pickle


class InvalidActionId(Exception):
	def __init__(self, action_id):
		Exception.__init__(self, "'%s' - non existent action" % action_id)

def getActionOutput(action_id, connection = None):
	if not connection:
		con = uSysDB.connect()
	else:
		con = connection
	
	cur = con.cursor()
	cur.execute("SELECT action_output FROM updater_atomic_actions WHERE action_id = %s", action_id)

	row = cur.fetchone()

	if not row:
		raise InvalidActionId(action_id)
	output_str = row[0]
	if output_str == None:
		return None
	else:
		return pickle.loads(str(output_str))

__all__ = [ "getActionOutput" ]
